summaryrefslogtreecommitdiff
path: root/tests/yacc-d-vpath.test
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2011-01-05 16:07:56 +0100
committerStefano Lattarini <stefano.lattarini@gmail.com>2011-01-09 16:14:09 +0100
commitc5b255bacb70ccb09b923f1a5acb4e6abca88385 (patch)
treebd88b869d70332f78320963859311b197f9da840 /tests/yacc-d-vpath.test
parent8c8c974284b0feb9d8f060d12d79d0373bb38dc4 (diff)
downloadautomake-c5b255bacb70ccb09b923f1a5acb4e6abca88385.tar.gz
yacc: extend and improve tests
* tests/yacc-basic.test: Also check that the intermediate C file is mentioned in the generated Makefile.in, and that it is created by the first make invocation. * tests/yacc3.test: Test removed, superseded by ... * tests/yacc-d-basic.test: ... this new test. * tests/yacc2.test: Add reference to that new test in the heading comments. * tests/yacc-d-vpath.test: New test. * tests/yaccvpath.test: Updated heading comments. Do not require gcc anymore, as any working C compiler should be enough. Remove redundant comments. * tests/yacc-nodist.test: New test. * tests/yacc-dist-nobuild.test: New test. * tests/Makefile.am (TESTS): Update.
Diffstat (limited to 'tests/yacc-d-vpath.test')
-rwxr-xr-xtests/yacc-d-vpath.test112
1 files changed, 112 insertions, 0 deletions
diff --git a/tests/yacc-d-vpath.test b/tests/yacc-d-vpath.test
new file mode 100755
index 000000000..0edaaa8a4
--- /dev/null
+++ b/tests/yacc-d-vpath.test
@@ -0,0 +1,112 @@
+#! /bin/sh
+# Copyright (C) 2011 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+# This test checks that dependent files are updated before including
+# in the distribution. `parse.c' depends on `parse.y'. The latter is
+# updated so that `parse.c' should be rebuilt. Then we are running
+# `make' and `make distdir' and check whether the version of `parse.c'
+# to be distributed is up to date.
+
+# Please keep this in sync with sister test `yaccvpath.test'.
+
+required=bison
+. ./defs || Exit 1
+
+set -e
+
+distdir=$me-1.0
+
+cat >> configure.in << 'END'
+AC_PROG_CC
+AC_PROG_YACC
+AC_OUTPUT
+END
+
+cat > Makefile.am << 'END'
+bin_PROGRAMS = foo
+foo_SOURCES = parse.y foo.c
+AM_YFLAGS = -d
+END
+
+# Original parser, with `foobar'
+cat > parse.y << 'END'
+%{
+int yylex () {return 0;}
+void yyerror (char *s) {}
+%}
+%token FOOBAR
+%%
+foobar : 'f' 'o' 'o' 'b' 'a' 'r' {};
+END
+
+cat > foo.c << 'END'
+#include "parse.h"
+int main () { return 0; }
+END
+
+$ACLOCAL
+$AUTOCONF
+$AUTOMAKE -a
+
+$YACC -d parse.y
+mv y.tab.c parse.c
+mv y.tab.h parse.h
+# Sanity checks.
+grep foobar parse.c
+grep FOOBAR parse.h
+
+mkdir sub
+cd sub
+../configure
+
+$sleep
+
+# New parser, with `fubar'
+cat > ../parse.y << 'END'
+%{
+int yylex () {return 0;}
+void yyerror (char *s) {}
+%}
+%token FUBAR
+%%
+fubar : 'f' 'u' 'b' 'a' 'r' {};
+END
+
+$MAKE
+$MAKE distdir
+$FGREP fubar $distdir/parse.c
+$FGREP FUBAR $distdir/parse.h
+
+# Now check to make sure that `make dist' will rebuild the parser.
+
+$sleep
+
+# New parser, with `maude'
+cat > ../parse.y << 'END'
+%{
+int yylex () {return 0;}
+void yyerror (char *s) {}
+%}
+%token MAUDE
+%%
+maude : 'm' 'a' 'u' 'd' 'e' {};
+END
+
+$MAKE distdir
+$FGREP maude $distdir/parse.c
+$FGREP MAUDE $distdir/parse.h
+
+: